package sinhalatts_vbeta;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.io.File;

/**
 * <p>Title: Sinhala TTS</p>
 * <p>Description: Beta Vertion</p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: UCSC_LTRL</p>
 * @author Viraj Welgama
 * @version Beta
 */

public class SinTTSBetaFrame
    extends JFrame {
  JPanel contentPane;
  BorderLayout borderLayout1 = new BorderLayout();
  JLabel jLabelFooter = new JLabel();
  JLabel jLabelWest = new JLabel();
  JLabel jLabelEast = new JLabel();
  JLabel jLabelHeader = new JLabel();
  JPanel jPanelMiddle = new JPanel();
  GridLayout gridLayout1 = new GridLayout();
  JPanel jPanel_Middle_Top = new JPanel();
  JPanel jPanel_Middle_Center = new JPanel();
  JPanel jPanel_Middle_Bottom = new JPanel();
  GridLayout gridLayout2 = new GridLayout();
  JPanel jPanel_Middle_Top_Top = new JPanel();
  JPanel jPanel_Middle_Top_Center = new JPanel();
  JPanel jPanel_Middle_Top_Bottom = new JPanel();
  FlowLayout flowLayout1 = new FlowLayout();
  JButton jButton_Open = new JButton();
  JButton jButton_Read = new JButton();
  JButton jButton_StopReading = new JButton();
  JButton jButton_Reset = new JButton();
  JButton jButton_Exit = new JButton();
  Border border1;
  TitledBorder titledBorder1;
  GridLayout gridLayout3 = new GridLayout();
  JPanel jPanel_Middle_Center_Top = new JPanel();
  JPanel jPanel_Middle_Center_Center = new JPanel();
  JPanel jPanel_Middle_Center_Bottom = new JPanel();
  GridLayout gridLayout4 = new GridLayout();
  JLabel jLabel_Status = new JLabel();
  GridLayout gridLayout5 = new GridLayout();
  GridLayout gridLayout6 = new GridLayout();
  JPanel jPanel_Middle_Bottom_Up = new JPanel();
  JPanel jPanel_Middle_Bottom_Down = new JPanel();
  JFileChooser jf = new JFileChooser();
  String InputPath;
  Border border2;
  TitledBorder titledBorder2;
  Border border3;
  JPanel jPanel_Middle_Center_Center_Center = new JPanel();
  Border border4;
  GridLayout gridLayout8 = new GridLayout();
  JProgressBar jProgressBar1 = new JProgressBar();
  Border border5;
  TitledBorder titledBorder3;
  Border border6;
  TitledBorder titledBorder4;
  Border border7;
  TitledBorder titledBorder5;
  GridLayout gridLayout7 = new GridLayout();
  JLabel jLabel_InputPath = new JLabel();

  Thread task;
  Process notepad;
  Process festival;

  //Construct the frame
  public SinTTSBetaFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception {
    contentPane = (JPanel)this.getContentPane();
    border1 = new EtchedBorder(EtchedBorder.RAISED, Color.white,
                               new Color(165, 163, 151));
    titledBorder1 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,
        Color.white, new Color(165, 163, 151)), "Status");
    border2 = BorderFactory.createEmptyBorder();
    titledBorder2 = new TitledBorder(border2, "Progress");
    border3 = new EtchedBorder(EtchedBorder.RAISED, Color.white,
                               new Color(165, 163, 151));
    border4 = new EtchedBorder(EtchedBorder.RAISED, Color.white,
                               new Color(165, 163, 151));
    border5 = new EtchedBorder(EtchedBorder.RAISED, Color.white,
                               new Color(165, 163, 151));
    titledBorder3 = new TitledBorder(border5, "Open File");
    border6 = new EtchedBorder(EtchedBorder.RAISED, Color.white,
                               new Color(165, 163, 151));
    titledBorder4 = new TitledBorder(border6, "Opened File");
    border7 = new EtchedBorder(EtchedBorder.RAISED, Color.white,
                               new Color(165, 163, 151));
    titledBorder5 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(165, 163, 151)),"File");
    jLabelFooter.setHorizontalAlignment(SwingConstants.CENTER);
    jLabelFooter.setIcon(new ImageIcon(SinTTSBetaFrame.class.getResource("Footer.JPG")));
    jLabelFooter.setIconTextGap(6);
    jLabelFooter.setText("");
    jLabelFooter.setForeground(SystemColor.desktop);
    jLabelFooter.setAlignmentY( (float) 1.0);
    contentPane.setLayout(borderLayout1);
    this.setResizable(false);
    this.setSize(new Dimension(493, 435));
    this.setTitle("Sinhala TTS - Alpha Version");
    jLabelWest.setText("        ");
    jLabelEast.setText("        ");
    jLabelHeader.setIcon(new ImageIcon(SinTTSBetaFrame.class.getResource(
        "header.jpg")));
    jLabelHeader.setText("jLabel4");
    jPanelMiddle.setLayout(gridLayout1);
    gridLayout1.setRows(3);
    jPanel_Middle_Top.setLayout(gridLayout2);
    gridLayout2.setRows(3);
    jPanel_Middle_Top_Center.setLayout(flowLayout1);
    jButton_Open.setText("Open");
    jButton_Open.setRequestFocusEnabled(false);
    jButton_Open.setMnemonic('O');
    jButton_Open.addActionListener(new
                                   SinTTSBetaFrame_jButton_Open_actionAdapter(this));
    jButton_Read.setEnabled(false);
    jButton_Read.setText("Read");
    jButton_Read.addActionListener(new
                                   SinTTSBetaFrame_jButton_Read_actionAdapter(this));
    jButton_Read.setMnemonic('R');
    jButton_StopReading.setEnabled(false);
    jButton_StopReading.setText("Abort");
    jButton_StopReading.setMnemonic('A');
    jButton_StopReading.addActionListener(new
        SinTTSBetaFrame_jButton_StopReading_actionAdapter(this));
    jButton_Reset.setEnabled(false);
    jButton_Reset.setText("Reset");
    jButton_Reset.addActionListener(new
                                    SinTTSBetaFrame_jButton_Reset_actionAdapter(this));
    jButton_Reset.setMnemonic('s');
    jButton_Exit.setText("Exit");
    jButton_Exit.addActionListener(new
                                   SinTTSBetaFrame_jButton_Exit_actionAdapter(this));
    jButton_Exit.setMnemonic('E');
    jPanel_Middle_Center.setForeground(Color.red);
    jPanel_Middle_Center.setBorder(titledBorder1);
    jPanel_Middle_Center.setLayout(gridLayout3);
    gridLayout3.setRows(3);
    jPanel_Middle_Center_Center.setLayout(gridLayout4);
    jLabel_Status.setFont(new java.awt.Font("Dialog", 1, 11));
    jLabel_Status.setForeground(SystemColor.desktop);
    jPanel_Middle_Center_Top.setLayout(gridLayout5);
    jPanel_Middle_Bottom.setLayout(gridLayout6);
    gridLayout6.setRows(2);
    jPanel_Middle_Center_Center.setBorder(border3);
    jPanel_Middle_Center_Center.setDebugGraphicsOptions(0);
    jPanel_Middle_Center_Center_Center.setBorder(border4);
    jPanel_Middle_Center_Center_Center.setLayout(gridLayout8);
    jProgressBar1.setForeground(Color.red);
    jPanel_Middle_Bottom_Down.setBorder(titledBorder5);
    jPanel_Middle_Bottom_Down.setLayout(gridLayout7);
    jLabel_InputPath.setForeground(SystemColor.desktop);
    jLabel_InputPath.setText("");
    contentPane.add(jLabelFooter, BorderLayout.SOUTH);
    contentPane.add(jLabelWest, BorderLayout.WEST);
    contentPane.add(jLabelEast, BorderLayout.EAST);
    contentPane.add(jLabelHeader, BorderLayout.NORTH);
    contentPane.add(jPanelMiddle, BorderLayout.CENTER);
    jPanelMiddle.add(jPanel_Middle_Top, null);
    jPanelMiddle.add(jPanel_Middle_Center, null);
    jPanelMiddle.add(jPanel_Middle_Bottom, null);
    jPanel_Middle_Top.add(jPanel_Middle_Top_Top, null);
    jPanel_Middle_Top.add(jPanel_Middle_Top_Center, null);
    jPanel_Middle_Top.add(jPanel_Middle_Top_Bottom, null);
    jPanel_Middle_Top_Center.add(jButton_Open, null);
    jPanel_Middle_Top_Center.add(jButton_Read, null);
    jPanel_Middle_Top_Center.add(jButton_StopReading, null);
    jPanel_Middle_Top_Center.add(jButton_Reset, null);
    jPanel_Middle_Top_Center.add(jButton_Exit, null);
    jPanel_Middle_Center.add(jPanel_Middle_Center_Top, null);
    jPanel_Middle_Center.add(jPanel_Middle_Center_Center, null);
    jPanel_Middle_Center_Center.add(jPanel_Middle_Center_Center_Center, null);
    jPanel_Middle_Center.add(jPanel_Middle_Center_Bottom, null);
    jPanel_Middle_Center_Top.add(jLabel_Status, null);
    jPanel_Middle_Bottom.add(jPanel_Middle_Bottom_Up, null);
    jPanel_Middle_Bottom.add(jPanel_Middle_Bottom_Down, null);
    jPanel_Middle_Center_Center_Center.add(jProgressBar1, null);
    jPanel_Middle_Bottom_Down.add(jLabel_InputPath, null);
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
 /*   super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
   //   deleteFiles();
    //  System.exit(0);
    }*/
  }

  void reset(int k) {
    jButton_StopReading.setEnabled(false);
    jProgressBar1.setIndeterminate(false);
    jButton_Read.setEnabled(false);
    if (k == 0) {
      jButton_Open.setEnabled(true);
      jButton_StopReading.setText("Abort");
      deleteFiles();
      jLabel_Status.setText("");
      jLabel_InputPath.setText("");
    }
    if (k == 1)
      jLabel_Status.setText("Aborted!");
    if (k == 2)
      jLabel_Status.setText("Stoped!");
  } //reset

  void jButton_Open_actionPerformed(ActionEvent e) {
    jf.setFileFilter(new TextFileFilter());
    int jfVal = jf.showOpenDialog(this);
    if (jfVal == jf.APPROVE_OPTION) {
      InputPath = jf.getSelectedFile().getAbsolutePath();
      jLabel_InputPath.setText(InputPath);
      jButton_Read.setEnabled(true);
      jButton_Reset.setEnabled(true);
      return;
    }
  }

  void jButton_Read_actionPerformed(ActionEvent e) {

    jButton_Open.setEnabled(false);
    jButton_Read.setEnabled(false);
    jButton_Reset.setEnabled(false);
    jButton_Exit.setEnabled(false);
    jButton_StopReading.setEnabled(true);
    final String viewPath = ".\\Resources\\SinTTSEditor.exe ".concat(InputPath);
    final String openPath = ".\\Resources\\SinTTS.exe --tts ".concat(
        TextNormalizerCaller.outFilePath);
    task = new Thread() {
      public void run() {
        int exitvalue;
        jLabel_Status.setText("Processing...");
        jProgressBar1.setForeground(Color.red);
        jProgressBar1.setIndeterminate(true);
        boolean Normalized = false;
        Normalized = TextNormalizerCaller.normalize(InputPath);
        if (Normalized) {
          try {
            notepad = Runtime.getRuntime().exec(viewPath);
            festival = Runtime.getRuntime().exec(openPath);
            jButton_StopReading.setText("Stop Reading");
            jLabel_Status.setText("Reading...");
            jProgressBar1.setForeground(Color.GREEN);
            jProgressBar1.setIndeterminate(true);
            exitvalue = festival.waitFor();
            if (exitvalue == festival.exitValue()) {
              jProgressBar1.setIndeterminate(false);
              jLabel_Status.setText("Read.");
              jButton_StopReading.setEnabled(false);
              jButton_Exit.setEnabled(true);
              jButton_Reset.setEnabled(true);
              notepad.destroy();
            }
          } //try
          catch (java.io.IOException ie) {}
          catch (InterruptedException ie) {}
          //catch(java.io. ye) {}
        } //if(Normalized)
      } //run
    };
    task.start();
  }

  void deleteFiles() {
    try {
      TextNormalizerCaller.closeFiles();
    }
    catch (java.io.IOException io) {}

    File out = new File(TextNormalizerCaller.tempFilePath);
    out.delete();
    out =  new File(TextNormalizerCaller.outFilePath);
    out.delete();

  }//deleteFiles()

  void jButton_Exit_actionPerformed(ActionEvent e) {
    deleteFiles();
    System.exit(100000);
  }

  void jButton_Reset_actionPerformed(ActionEvent e) {
    reset(0);
    jButton_Reset.setEnabled(false);
  }

  void jButton_StopReading_actionPerformed(ActionEvent e) {

    if (jButton_StopReading.getText().equals("Abort")) {
      if (task.isAlive())
        task.suspend();
      jProgressBar1.setIndeterminate(false);
      int k = JOptionPane.showConfirmDialog(this,
          "This will abort the current process. "
          + "\nDo you want to abort?",
          "Sinhala TTS - Alpha Version",
          JOptionPane.YES_NO_OPTION);
      if (k == JOptionPane.NO_OPTION) {
        jProgressBar1.setIndeterminate(true);
        task.resume();
      }
      if (k == JOptionPane.YES_OPTION) {
        task.stop();

        JOptionPane.showMessageDialog(this,
                                      "Process aborted by user !",
                                      "Sinhala TTS - Alpha Version", JOptionPane.WARNING_MESSAGE);
        jButton_Reset.setEnabled(true);
        jButton_Exit.setEnabled(true);
        reset(1);
      }
    }//if Abort

    if (jButton_StopReading.getText().equals("Stop Reading")) {
      if (task.isAlive())
        task.suspend();
      jProgressBar1.setIndeterminate(false);
      int k = JOptionPane.showConfirmDialog(this,
                                            "This will stop reading... "
                                            + "\nDo you want to stop?",
                                            "Sinhala TTS - Alpha Version",
                                            JOptionPane.YES_NO_OPTION);

      if (k == JOptionPane.YES_OPTION) {
        notepad.destroy();
        festival.destroy();
        JOptionPane.showMessageDialog(this,
                                      "Reading stoped by user !",
                                      "Sinhala TTS - Alpha Version", JOptionPane.WARNING_MESSAGE);
        jButton_Reset.setEnabled(true);
        jButton_Exit.setEnabled(true);
        reset(2);
      }
    }//Stop Reading
  }
}

class SinTTSBetaFrame_jButton_Open_actionAdapter
    implements java.awt.event.ActionListener {
  SinTTSBetaFrame adaptee;

  SinTTSBetaFrame_jButton_Open_actionAdapter(SinTTSBetaFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jButton_Open_actionPerformed(e);
  }
}

class SinTTSBetaFrame_jButton_Read_actionAdapter
    implements java.awt.event.ActionListener {
  SinTTSBetaFrame adaptee;

  SinTTSBetaFrame_jButton_Read_actionAdapter(SinTTSBetaFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jButton_Read_actionPerformed(e);
  }
}

class SinTTSBetaFrame_jButton_Exit_actionAdapter
    implements java.awt.event.ActionListener {
  SinTTSBetaFrame adaptee;

  SinTTSBetaFrame_jButton_Exit_actionAdapter(SinTTSBetaFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jButton_Exit_actionPerformed(e);
  }
}

class SinTTSBetaFrame_jButton_Reset_actionAdapter
    implements java.awt.event.ActionListener {
  SinTTSBetaFrame adaptee;

  SinTTSBetaFrame_jButton_Reset_actionAdapter(SinTTSBetaFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jButton_Reset_actionPerformed(e);
  }
}

class SinTTSBetaFrame_jButton_StopReading_actionAdapter
    implements java.awt.event.ActionListener {
  SinTTSBetaFrame adaptee;

  SinTTSBetaFrame_jButton_StopReading_actionAdapter(SinTTSBetaFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jButton_StopReading_actionPerformed(e);
  }
}