/** This can reads Unicode format files & can rewrite it to another file */
/** Author: Viraj Welgama
 * LTRL - UCSC
 * March 2005
 */
package sinhalatts_vbeta;

import java.io.*;
import java.util.ArrayList;

class UnicodeFileReWriter {

  private static ArrayList passer(ArrayList needtoPass) {
    ArrayList result = new ArrayList();
    String Btemp = "";
    String Atemp = "";
    for (int i = 0; i < needtoPass.size(); i++) {
      Btemp = needtoPass.get(i).toString();
      Atemp = Btemp.substring(2);
      Atemp = Atemp.concat(Btemp.substring(0, 2));
      result.add(Atemp);
    }
    return result;
  } //passer

  public static int writer(RandomAccessFile raf, ArrayList needtoPass) throws IOException {
    ArrayList passData = passer(needtoPass);
    for (int i = 0; i < passData.size(); i++)
      raf.writeChar(Integer.valueOf(passData.get(i).toString(), 16).intValue());
    //raf.close();
    return passData.size();
  } //writer

  public static ArrayList reader(String input) throws IOException {
    FileInputStream fis = new FileInputStream(input);
    DataInputStream fin = new DataInputStream(fis);
    fin.read();
    fin.read();
    int ihead = 0;
    int irear = 0;
    String shead = "";
    String srear = "";
    ArrayList v = new ArrayList(1);
    int limit = (fin.available()) / 2;
    for (int i = 0; i < limit; i++) {
      irear = fin.read();
      srear = (irear < 16) ? "0".concat(Integer.toHexString(irear)) :
          Integer.toHexString(irear);
      ihead = fin.read();
      shead = (ihead < 16) ? "0".concat(Integer.toHexString(ihead)) :
          Integer.toHexString(ihead);
      v.add(shead.concat(srear));
    }
    return v;
  } //reader

  public static void main(String s[]) {
    try {
    RandomAccessFile raf = new RandomAccessFile(s[0].substring(0,
        s[0].length() - 4).concat("_ReWrite.txt"), "rw");
      int size = writer(raf, reader(s[0]));
      System.out.println("Done!\n" + size*2 + " bytes (" + size + " words) have been writen in to the file.");
    } //try
    catch (IOException io) {
      System.out.println(io.toString());
      io.printStackTrace(System.err);
    } //catch

  } //main

} //class