/** this can reads Uniocde format files and can retrun them line by line */
/** Author: Viraj Welgama
 * LTRL - UCSC
 * March 2005
 */
package sinhalatts_vbeta;

import java.io.*;
import java.util.*;

class UnicodeFileReader {

  private FileInputStream fis;
  private DataInputStream fin;
  private boolean EOF = false;
  private int length = 0;

  public UnicodeFileReader(String path) {
    try {
      fis = new FileInputStream(path);
      fin = new DataInputStream(fis);
      fin.read();
      fin.read();
      length = fin.available();
    }//try
    catch (IOException io) {
      System.out.println(io.toString());
      io.printStackTrace(System.err);
    } //catch
  } //constructor

  public ArrayList readLine() throws IOException {
        int ihead = 0;
        int irear = 0;
        ArrayList v = new ArrayList(1);
        String shead = "";
        String srear = "";
        while (true) {
          if(fin.available()==0) { EOF = true; break; }
          irear = fin.read();
          ihead = fin.read();
          srear = (irear < 16) ? "0".concat(Integer.toHexString(irear)) :
              Integer.toHexString(irear);
          shead = (ihead < 16) ? "0".concat(Integer.toHexString(ihead)) :
              Integer.toHexString(ihead);
          if (shead.concat(srear).equals("000a") &&
              v.get(v.size()-1).toString().equals("000d")) {
            v.remove(v.size() - 1);
            break;
          }
          v.add(shead.concat(srear));
        }
        v.trimToSize();
        return v;
    } //readLine

    public boolean isEnd() {
      return EOF;
    }//isEnd

} //class
