/** This can tokenize a Uniocde format files, to a tokens */
/** Author: Viraj Welgama
 * LTRL - UCSC
 * March 2005
 */
package sinhalatts_vbeta;

import java.io.*;
import java.util.*;

class UnicodeFileTokenizer {

  private int length = 0;
  private boolean isEnd = false;
  private int noOfTokens = 0;
  private String USER_TOKEN = "";
  private ArrayList CHAR_TOKENS = new ArrayList(1);

  private FileInputStream fis;
  private DataInputStream fin;

  private boolean isEnter = false;

//////////////////////////////////////////////////////////////////////////////

  public UnicodeFileTokenizer(String path) {
    try {
      fis = new FileInputStream(path);
      fin = new DataInputStream(fis);
      fin.read();
      fin.read();
      length = fin.available();
      USER_TOKEN = "0020";
    } //try
    catch (IOException io) {
      System.out.println(io.toString());
      io.printStackTrace(System.err);
    } //catch
  } //constructor() 1

//////////////////////////////////////////////////////////////////////////////

  public UnicodeFileTokenizer(String path, String TOKEN, String Uni) {
    try {
      fis = new FileInputStream(path);
      fin = new DataInputStream(fis);
      fin.read();
      fin.read();
      length = fin.available();
      USER_TOKEN = TOKEN;
     } //try
    catch (IOException io) {
      System.out.println(io.toString());
      io.printStackTrace(System.err);
    } //catch
  } //constructor() 2

//////////////////////////////////////////////////////////////////////////////

  public UnicodeFileTokenizer(String path, char TOKEN) {
    try {
      fis = new FileInputStream(path);
      fin = new DataInputStream(fis);
      fin.read();
      fin.read();
      length = fin.available();
      int value = ((byte)TOKEN < 0)? (byte)TOKEN + 256 : (byte)TOKEN;
      String charval = (value < 16) ? "0".concat(Integer.toHexString(value)) :
              Integer.toHexString(value);
      USER_TOKEN = "00".concat(charval);
    } //try
    catch (IOException io) {
      System.out.println(io.toString());
      io.printStackTrace(System.err);
    } //catch
  } //constructor() 3

//////////////////////////////////////////////////////////////////////////////

  public UnicodeFileTokenizer(String path, String TOKEN) {
    try {
      fis = new FileInputStream(path);
      fin = new DataInputStream(fis);
      fin.read();
      fin.read();
      length = fin.available();
      for (int i = 0; i < TOKEN.length(); i++) {
        int value = ( (byte) TOKEN.charAt(i) < 0) ?
            (byte) TOKEN.charAt(i) + 256 : (byte) TOKEN.charAt(i);
        String charval = (value < 16) ?
            "0".concat(Integer.toHexString(value)) :
            Integer.toHexString(value);
        CHAR_TOKENS.add("00".concat(charval));
      }
     } //try
    catch (IOException io) {
      System.out.println(io.toString());
      io.printStackTrace(System.err);
    } //catch
  } //constructor() 4

//////////////////////////////////////////////////////////////////////////////

  public ArrayList nextToken() throws IOException{
    if(CHAR_TOKENS.isEmpty())
      return nextToken(1);
    else
      return nextToken(true);
  }//nextToken()

//////////////////////////////////////////////////////////////////////////////

  private ArrayList nextToken(int notify) throws IOException{
    ArrayList word = new ArrayList(1);
    String oneByte = "";
    while (!isEnd()) {
      if(fin.available()==0) {
        isEnd = true;
        break;
      }
      oneByte = readByte();
      if(oneByte.equals("000d")) isEnter = true;
      if (word.isEmpty() && (oneByte.equals(USER_TOKEN) || oneByte.equals("000d"))) continue;
      if (oneByte.equals(USER_TOKEN) || oneByte.equals("000d")) break;
      if(!oneByte.equals("000a")) word.add(oneByte);
    } //while
    return word;
  } //nextToken(int)

//////////////////////////////////////////////////////////////////////////////

  private ArrayList nextToken(boolean notify) throws IOException{
    ArrayList word = new ArrayList(1);
    String oneByte = "";
    while (!isEnd()) {
      if(fin.available()==0) {
        isEnd = true;
        break;
      }
      oneByte = readByte();
      if(oneByte.equals("000d")) isEnter = true;
      if (word.isEmpty() && (CHAR_TOKENS.contains(oneByte) || oneByte.equals("000d"))) continue;
      if (CHAR_TOKENS.contains(oneByte) || oneByte.equals("000d")) break;
      if(!oneByte.equals("000a")) word.add(oneByte);
    } //while
    return word;
  } //nextToken(boolean)

  private String readByte() throws IOException{
    isEnter = false;
    int irear = fin.read();
    int ihead = fin.read();
    String srear = (irear < 16) ? "0".concat(Integer.toHexString(irear)) :
        Integer.toHexString(irear);
    String shead = (ihead < 16) ? "0".concat(Integer.toHexString(ihead)) :
        Integer.toHexString(ihead);
    return shead.concat(srear);
  } //readByte()

  public boolean isEnd() {
    return isEnd;
  }//isEnd()

  public boolean isEnter() {
    return isEnter;
  }//isEnter()

} //class