/** This can tokenize a Uniocde format lines, to a tokens */
/** Author: Viraj Welgama
 * LTRL - UCSC
 * March 2005
 */
package sinhalatts_vbeta;

import java.io.*;
import java.util.*;

class UnicodeTokenizer {

  final private ArrayList sentence;
  private int length = 0;
  private boolean isEnd = false;
  private int noOfTokens = 0;
  private String USER_TOKEN = "";
  private ArrayList CHAR_TOKENS = new ArrayList(1);

  public UnicodeTokenizer(ArrayList input) {
    sentence = input;
    USER_TOKEN = "0020";
  } //constructor() 1

  public UnicodeTokenizer(ArrayList input, String TOKEN, String Uni) {
    sentence = input;
    USER_TOKEN = TOKEN;
  } //constructor() 2

  public UnicodeTokenizer(ArrayList input, char TOKEN) {
    sentence = input;
    String charval = ((byte)TOKEN < 16) ? "0".concat(Integer.toHexString((byte)TOKEN)) :
            Integer.toHexString((byte)TOKEN);
    USER_TOKEN = "00".concat(charval);
  } //constructor() 3

  public UnicodeTokenizer(ArrayList input, String TOKEN) {
    sentence = input;
    for(int i=0; i<TOKEN.length(); i++) {
      String charval = ( (byte) TOKEN.charAt(i) < 16) ?
          "0".concat(Integer.toHexString( (byte) TOKEN.charAt(i))) :
          Integer.toHexString( (byte) TOKEN.charAt(i));
      CHAR_TOKENS.add("00".concat(charval));
    }
  } //constructor() 4

  public ArrayList nextToken() {
    if(CHAR_TOKENS.isEmpty())
      return nextToken(1);
    else
      return nextToken(true);
  }//nextToken()

  private ArrayList nextToken(int notify) {
    ArrayList word = new ArrayList(1);
    while (!isEnd()) {
      if (length == sentence.size()) {
        isEnd = true;
        break;
      }
      if (word.isEmpty() && sentence.get(length).equals(USER_TOKEN)) {
        length++;
        continue;
      }
      if (sentence.get(length).equals(USER_TOKEN)) {
        length++;
        break;
      }
      word.add(sentence.get(length++));
    } //while
    return word;
  } //nextToken(int)

  private ArrayList nextToken(boolean notify) {
    ArrayList word = new ArrayList(1);
    while (!isEnd()) {
      if (length == sentence.size()) {
        isEnd = true;
        break;
      }
      if (word.isEmpty() && CHAR_TOKENS.contains(sentence.get(length))) {
        length++;
        continue;
      }
      if (CHAR_TOKENS.contains(sentence.get(length))) {
        length++;
        break;
      }
      word.add(sentence.get(length++));
    } //while
    return word;
  } //nextToken()

  public int noOfTokens() {
    if (CHAR_TOKENS.isEmpty())
      return noOfTokens(1);
    else
      return noOfTokens(true);
  } //noOfTokens()

  private int noOfTokens(int notify) {
    for (int i = 0; i < sentence.size() - 1; i++) {
      if (sentence.get(i).equals(USER_TOKEN) && !sentence.get(i + 1).equals(USER_TOKEN))
        noOfTokens++;
    }
    return ++noOfTokens;
  } //noOfTokens(int)

  private int noOfTokens(boolean notify) {
    boolean notFirst = false;
    for (int i = 0; i < sentence.size() - 1; i++) {
      if(!CHAR_TOKENS.contains(sentence.get(i))) notFirst = true;
      if (CHAR_TOKENS.contains(sentence.get(i)) && !CHAR_TOKENS.contains(sentence.get(i+1)) && notFirst)
        noOfTokens++;
    }
    return ++noOfTokens;
  } //noOfTokens(boolean)

  public boolean isEnd() {
    return isEnd;
  }//isEnd()

} //class